﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace Scheduler
{
    class Logger
    {
        const string SCHEDULE_LOG_PATH = @"/home/pi/scheduler/logs/pi_schedule.log";
        const string ERROR_LOG_PATH = @"/home/pi/scheduler/logs/pi_error.log";

        static public void LogScheduleStats(string timeStamp, string scheduleAction)
        {
            try
            {
                using (StreamWriter schedule_log = File.AppendText(SCHEDULE_LOG_PATH))
                {
                    schedule_log.WriteLine(timeStamp + "," + scheduleAction);
                }
            }
            catch(Exception e)
            {
                ReportError(e.Message);
            }
        }

        static public void LogError(string timeStamp, string errorMessage)
        {
            try
            {
                using (StreamWriter error_log = File.AppendText(ERROR_LOG_PATH))
                {
                    error_log.WriteLine(timeStamp + "," + errorMessage);
                }
            }
            catch(Exception e)
            {
                ReportError(e.Message);
            }
        }

        static void ReportError(string error)
        {
            Console.WriteLine("The logs files could not be found:");
            Console.WriteLine();
            Console.WriteLine(error);
            Console.WriteLine();
            Console.WriteLine("Did you remember to create your schedule and error text files for logging? The folling directory and file should exist:\r\n\r\n");
            Console.WriteLine(SCHEDULE_LOG_PATH);
            Console.WriteLine();
            Console.WriteLine(ERROR_LOG_PATH);
        }
    }
}
